import { Initializable } from '@pilotlab/initializable';
import { IPromise, Result } from '@pilotlab/result';
import { Signal } from '@pilotlab/signals';
import INode from './interfaces/iNode';
import INodeChangeOptions from './interfaces/iNodeChangeOptions';
import INodes from './interfaces/iNodes';
import INodeFactory from './interfaces/iNodeFactory';
import INodeNavigator from './interfaces/iNodeNavigator';
import { NodeType } from './nodeEnums';
import { NodeEventArgs } from './nodeEventArgs';
import { NodeNavigator } from './nodeNavigator';
export declare abstract class NodeBase<TNode extends INode, TNodes extends INodes, TRoot extends INode> extends Initializable implements INode {
    protected constructor(factory: INodeFactory, nodeType?: NodeType, key?: string, isInitialize?: boolean);
    protected p_onInitializeStarted(result: Result<any>, args: any[]): IPromise<any>;
    readonly create: INodeFactory;
    protected p_factory: INodeFactory;
    readonly isAttached: boolean;
    internalIsAttached: boolean;
    key: string;
    protected p_key: string;
    readonly parent: TNode;
    readonly parentCollection: TNodes;
    internalParentCollection: TNodes;
    readonly root: TRoot;
    protected p_root: TRoot;
    readonly isRoot: boolean;
    readonly isCollection: boolean;
    readonly children: TNodes;
    protected p_onSetChildCollection(nodeType: NodeType): void;
    protected p_children: TNodes;
    isSignalChange: boolean;
    protected p_isSignalChange: boolean;
    nodeType: NodeType;
    protected p_setNodeType(value: NodeType, changeOptions: INodeChangeOptions): NodeBase<any, any, any>;
    protected p_nodeType: NodeType;
    protected p_onNodeTypeChanged(type: NodeType, changeOptions: INodeChangeOptions): void;
    readonly path: string;
    index: number;
    protected p_index: number;
    readonly indexPrevious: number;
    protected p_indexPrevious: number;
    internalSetIndex(value: number, changeOptions: INodeChangeOptions): void;
    protected p_onIndexSet(indexNew: number, indexPrevious: number, changeOptions: INodeChangeOptions): void;
    setIndex(value: number, changeOptions?: INodeChangeOptions, isRememberCurrentIndex?: boolean, isSoftSwap?: boolean): boolean;
    readonly nestLevel: number;
    readonly copy: TNode;
    readonly added: Signal<NodeEventArgs<TNode>>;
    readonly attached: Signal<NodeEventArgs<TNode>>;
    readonly deleted: Signal<NodeEventArgs<TNode>>;
    readonly detached: Signal<NodeEventArgs<TNode>>;
    readonly indexChanged: Signal<NodeEventArgs<TNode>>;
    readonly changed: Signal<NodeEventArgs<TNode>>;
    private readonly _changed;
    delete(changeOptions?: INodeChangeOptions): IPromise<boolean>;
    returnToPreviousIndex(changeOptions?: INodeChangeOptions): boolean;
    toObject(isIncludeDataTypes?: boolean, isIncludeLabels?: boolean, appendToObject?: any, isForceInclude?: boolean): any;
    toJson(isIncludeDataTypes?: boolean): string;
    internalChanged(args: NodeEventArgs<any>): void;
    internalAdded(changeOptions: INodeChangeOptions): void;
    protected p_onAdded(changeOptions: INodeChangeOptions): void;
    internalAttached(changeOptions: INodeChangeOptions): void;
    protected p_onAttached(changeOptions: INodeChangeOptions): void;
    internalDeleted(changeOptions: INodeChangeOptions): void;
    protected p_onDeleted(changeOptions: INodeChangeOptions): void;
    internalDetached(changeOptions: INodeChangeOptions): void;
    protected p_onDetached(changeOptions: INodeChangeOptions): void;
    readonly navigate: INodeNavigator;
    protected p_navigator: NodeNavigator<TNode>;
}
export default NodeBase;
